<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResaleRequestDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResaleRequestDetails
 * @subpackage Arrays
 */
class ArrayOfResaleRequestDetails extends AbstractStructArrayBase
{
    /**
     * The ResaleRequestDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\ResaleRequestDetails[]
     */
    public $ResaleRequestDetails;
    /**
     * Constructor method for ArrayOfResaleRequestDetails
     * @uses ArrayOfResaleRequestDetails::setResaleRequestDetails()
     * @param \patest\StructType\ResaleRequestDetails[] $resaleRequestDetails
     */
    public function __construct(array $resaleRequestDetails = array())
    {
        $this
            ->setResaleRequestDetails($resaleRequestDetails);
    }
    /**
     * Get ResaleRequestDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\ResaleRequestDetails[]|null
     */
    public function getResaleRequestDetails()
    {
        return isset($this->ResaleRequestDetails) ? $this->ResaleRequestDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setResaleRequestDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResaleRequestDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResaleRequestDetailsForArrayConstraintsFromSetResaleRequestDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResaleRequestDetailsResaleRequestDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfResaleRequestDetailsResaleRequestDetailsItem instanceof \patest\StructType\ResaleRequestDetails) {
                $invalidValues[] = is_object($arrayOfResaleRequestDetailsResaleRequestDetailsItem) ? get_class($arrayOfResaleRequestDetailsResaleRequestDetailsItem) : sprintf('%s(%s)', gettype($arrayOfResaleRequestDetailsResaleRequestDetailsItem), var_export($arrayOfResaleRequestDetailsResaleRequestDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResaleRequestDetails property can only contain items of type \patest\StructType\ResaleRequestDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResaleRequestDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ResaleRequestDetails[] $resaleRequestDetails
     * @return \patest\ArrayType\ArrayOfResaleRequestDetails
     */
    public function setResaleRequestDetails(array $resaleRequestDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($resaleRequestDetailsArrayErrorMessage = self::validateResaleRequestDetailsForArrayConstraintsFromSetResaleRequestDetails($resaleRequestDetails))) {
            throw new \InvalidArgumentException($resaleRequestDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($resaleRequestDetails) || (is_array($resaleRequestDetails) && empty($resaleRequestDetails))) {
            unset($this->ResaleRequestDetails);
        } else {
            $this->ResaleRequestDetails = $resaleRequestDetails;
        }
        return $this;
    }
    /**
     * Add item to ResaleRequestDetails value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\ResaleRequestDetails $item
     * @return \patest\ArrayType\ArrayOfResaleRequestDetails
     */
    public function addToResaleRequestDetails(\patest\StructType\ResaleRequestDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\ResaleRequestDetails) {
            throw new \InvalidArgumentException(sprintf('The ResaleRequestDetails property can only contain items of type \patest\StructType\ResaleRequestDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResaleRequestDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\ResaleRequestDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\ResaleRequestDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\ResaleRequestDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\ResaleRequestDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\ResaleRequestDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResaleRequestDetails
     */
    public function getAttributeName()
    {
        return 'ResaleRequestDetails';
    }
}
